*-- File: CURSOR.CC

CLASS Cursor
*----------------------------------------------------------------------
*-- Description:
*
*      This UI class is designed to work with your windows cursor.
*
*-- Programmers: 
*
*      Ken Mayer
*      Bowen Moursund (CIS: 72662,436)
*
*-- History: 
*
*      11/28/1996 -- original version of these routines as a class.
*
*-- Instantiation: 
*
*      set procedure to cursor.cc additive
*      _app.Cursor = new Cursor()
*
*-- Methods:
*      More details on each of these is contained in the commentary for
*      each method ...
*   
*--    Release()
*        Releases this object (and others) from memory
*
*--    BeginWait()
*        Turns cursor into 'hourglass' (or whatever your 'wait' cursor
*        is set to)
*
*--    EndWait()
*        Returns cursor to previous state (turn off 'hourglass')
*
*-- Properties:
*
*      None
*
*----------------------------------------------------------------------

   FUNCTION Release
   *-------------------------------------------------------------------
   *-- Programmer..: Ken Mayer
   *-- Date........: 11/24/1996
   *-- Notes.......: Used to release this object from memory.
   *-- Written for.: Visual dBASE 5.5
   *-- Rev. History: 11/24/1996 -- Original Code
   *-- Calls.......: none
   *-- Usage.......: cursor.Release()
   *-- Example.....: _app.Cursor.Release()
   *--               _app.Cursor = NULL   && not required, but a good 
   *--                                    && idea
   *-- Returns.....: Null
   *-- Parameters..: None
   *-------------------------------------------------------------------
      release object this

   RETURN NULL
   *-- EoM: Release()


   FUNCTION BeginWait
   *-------------------------------------------------------------------
   *-- Programmer..: Bowen Moursund (CIS: 72662,436)
   *-- Date........: 11/28/1996
   *-- Notes.......: set hourglass mousepointer, capture mouse events
   *-- Written for.: Visual dBASE 5.5
   *-- Rev. History: ? -- Original Code
   *                 11/28/1996 -- modified for dUFLP library
   *-- Calls.......: none
   *-- Usage.......: cursor.BeginWait()
   *-- Example.....: _app.Cursor.BeginWait()
   *-- Returns.....: Null
   *-- Parameters..: None
   *-------------------------------------------------------------------
   
      *-- set hourglass mousepointer, capture mouse events
      if type("SetCursor") # "FP"
         extern CHANDLE SetCursor ( CHANDLE )  USER.EXE
      endif
      if type("LoadCursor") # "FP"
         extern CHANDLE LoadCursor ( CSTRING,CHANDLE ) USER.EXE
      endif
      if type("SetCapture") # "FP"
         extern CHANDLE SetCapture ( CHANDLE ) USER.EXE
      endif
      SetCursor(LoadCursor(0,32514))  && 32514 = hourglass mousepointer
      SetCapture(_app.framewin.hWnd)
      
   RETURN NULL
   *-- EoM: BeginWait

   PROCEDURE EndWait
   *-------------------------------------------------------------------
   *-- Programmer..: Bowen Moursund (CIS: 72662,436)
   *-- Date........: 11/28/1996
   *-- Notes.......: Reset mousepointer, release capture of mouse 
   *                 events
   *-- Written for.: Visual dBASE 5.5
   *-- Rev. History: ? -- Original Code
   *                 11/28/1996 -- modified for dUFLP library
   *-- Calls.......: none
   *-- Usage.......: cursor.EndWait()
   *-- Example.....: _app.Cursor.EndWait()
   *-- Returns.....: Null
   *-- Parameters..: None
   *-------------------------------------------------------------------

      if type("ReleaseCapture") # "FP"
         extern CVOID ReleaseCapture ( CVOID ) USER.EXE
      endif
      clear typeahead
      ReleaseCapture()

   RETURN NULL
   *-- EoM: EndWait

ENDCLASS
*-- End of Class: CURSOR

*-----------------------------------------------------------------------
*-- End of File: CURSOR.CC
*-----------------------------------------------------------------------